//+------------------------------------------------------------------+
//|                                              AscTrend_NonLag.mq4 |
//|                                        code by Newdigital        |
//|                                        http://www.forex-tsd.com  |
//|                                                                  |
//|                                                                  |
//|                                                                  |
//|  M30 timeframe                                                   |
//+------------------------------------------------------------------+

#property copyright "newdigital"
#property link      "http://www.forex-tsd.com"

extern int MAGIC = 363200;

extern string PARAMETERS_TRADE = "PARAMETERS TRADE";
extern double Lots = 0.10;
extern int Slippage = 4;
extern double lStopLoss = 60;
extern double sStopLoss = 60;


extern string PARAMETERS_EXPERT = "PARAMETERS EXPERT";
extern color clOpenBuy = Blue;
extern color clCloseBuy = Aqua;
extern color clOpenSell = Red;
extern color clCloseSell = Violet;
extern color clModiBuy = Blue;
extern color clModiSell = Red;
extern string Name_Expert = "AscTrend_NonLag";
extern bool UseSound = False;
extern string NameFileSound = "alert.wav";
extern bool UseHourTrade = False;
extern int FromHourTrade = 8;
extern int ToHourTrade = 19;

extern string PARAMETERS_INDICATOR_ONE  = "RSIFilter_v1";
extern int PeriodRSI=9;

extern string PARAMETERS_INDICATOR_TWO = "NonLagMA_v4";
extern int     Price          = 0;
extern int     Length         = 100;
extern int     Displace       = 0;
extern int     Filter         = 1;
extern int     Color          = 1;
extern int     ColorBarBack   = 0;
extern double  Deviation      = 0;
double Cycle =  4; 

extern string PARAMETERS_INDICATOR_THREE  = "ASCTrend_Sound";
extern int RISK=3;
extern int CountBars=300;
int SoundON=0;
int EmailON=0;

void deinit() {
   Comment("");
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start(){
   if (UseHourTrade){
      if (!(Hour()>=FromHourTrade && Hour()<=ToHourTrade)) {
         Comment("Time for trade has not come else!");
         return(0);
   }  
   }
   if(Bars<100){
      Print("bars less than 100");
      return(0);
   }
   if(lStopLoss<10){
      Print("StopLoss less than 10");
      return(0);
   }
   
  
   if(sStopLoss<10){
      Print("StopLoss less than 10");
      return(0);
   }
   

double diRSIFilterup=iCustom(NULL,0,"RSIFilter_v1",PeriodRSI,0,1);
double diRSIFilterdown=iCustom(NULL,0,"RSIFilter_v1",PeriodRSI,1,1);
double d22=(0);
  
double diNonLagNonTrade=iCustom(NULL,0,"NonLagMA_v4.1",Price,Length,Displace,Filter,Color,ColorBarBack,Deviation,0,2);
double d23=(0);
double diNonLagUp=iCustom(NULL,0,"NonLagMA_v4.1",Price,Length,Displace,Filter,Color,ColorBarBack,Deviation,1,1);
double diNonLagDown=iCustom(NULL,0,"NonLagMA_v4.1",Price,Length,Displace,Filter,Color,ColorBarBack,Deviation,2,1);
double d24=(0);

//exit rules
double diNonLagNonTrade1=iCustom(NULL,0,"NonLagMA_v4.1",Price,Length,Displace,Filter,Color,ColorBarBack,Deviation,0,1);
double d25=(0);
double diNonLagUp1=iCustom(NULL,0,"NonLagMA_v4.1",Price,Length,Displace,Filter,Color,ColorBarBack,Deviation,1,2);
double diNonLagDown1=iCustom(NULL,0,"NonLagMA_v4.1",Price,Length,Displace,Filter,Color,ColorBarBack,Deviation,2,2);
double d26=(0);

Print(" Up=",diNonLagUp," Dn=",diNonLagDown,);
   if(AccountFreeMargin()<(1000*Lots)){
      Print("We have no money. Free Margin = ", AccountFreeMargin());
      return(0);
   }
   if (!ExistPositions()){

      if ((diRSIFilterup>d22 && diNonLagUp > 0 && diNonLagDown1 > 0)){
         OpenBuy();
         return(0);
      }

      if ((diRSIFilterdown<d22 && diNonLagDown > 0 && diNonLagUp1 > 0 )){
         OpenSell();
         return(0);
      }
   }
   if (ExistPositions()){
      if(OrderType()==OP_BUY){

         if ((diNonLagDown > 0 && diNonLagUp1 > 0)){
            CloseBuy();
            return(0);
         }
      }
      if(OrderType()==OP_SELL){

         if ((diNonLagUp > 0 && diNonLagDown1 > 0)){
            CloseSell();
            return(0);
         }
      }
   }
   return (0);
}

bool ExistPositions() {
	for (int i=0; i<OrdersTotal(); i++) {
		if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
			if (OrderSymbol()==Symbol() && OrderMagicNumber()==MAGIC) {
				return(True);
			}
		} 
	} 
	return(false);
}

 

void CloseBuy() { 
   bool fc; 
   fc=OrderClose(OrderTicket(), OrderLots(), Bid, Slippage, clCloseBuy); 
   if (fc && UseSound) PlaySound(NameFileSound); 
} 
void CloseSell() { 
   bool fc; 
   fc=OrderClose(OrderTicket(), OrderLots(), Ask, Slippage, clCloseSell); 
   if (fc && UseSound) PlaySound(NameFileSound); 
} 
void OpenBuy() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLot(); 
   ldStop = GetStopLossBuy(); 
   ldTake = 0; 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_BUY,ldLot,Ask,Slippage,ldStop,ldTake,lsComm,MAGIC,0,clOpenBuy); 
   if (UseSound) PlaySound(NameFileSound); 
} 
void OpenSell() { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 

   ldLot = GetSizeLot(); 
   ldStop = GetStopLossSell(); 
   ldTake = 0; 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_SELL,ldLot,Bid,Slippage,ldStop,ldTake,lsComm,MAGIC,0,clOpenSell); 
   if (UseSound) PlaySound(NameFileSound); 
} 
string GetCommentForOrder() { 	return(Name_Expert); } 
double GetSizeLot() { 	return(Lots); } 
double GetStopLossBuy() { 	return (Bid-lStopLoss*Point);} 
double GetStopLossSell() { 	return(Ask+sStopLoss*Point); } 

